两数之和
题目地址: 力扣(LeetCode)官网 - 全球极客挚爱的技术成长平台
简单来说就是在一个数组中找出两个数,这两个数相加要等于给定的target,下面是完整的题目:
给定一个整数数组 nums
和一个整数目标值 target
,请你在该数组中找出 和为目标值 target
的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9 输出:[0,1] 解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例 2:
输入:nums = [3,2,4], target = 6 输出:[1,2]
示例 3:
输入:nums = [3,3], target = 6 输出:[0,1]
暴力法
看到这个题目最简单的想法就是双重遍历,把值相加,然后返回对应的下标
public int[] twoSum1(int[] nums, int target) {
for (int i = 0; i < nums.length; i++) {
for (int j = 0; j < nums.length; j++) {
//双重遍历,如果相加等于target则返回下标
if (nums[i] + nums[j] == target) {
return new int[]{i, j};
}
}
}
throw new IllegalArgumentException("no solution");
}
打开力扣网址,选择java,把代码贴进去,点运行
看右下角,发现执行测试用例时报错了
因为同一个元素不能重复出现,所以需要优化下
public int[] twoSum1(int[] nums, int target) {
// 第一层循环到倒数第二个
for (int i = 0; i < nums.length - 1; i++) {
// 第二层循环从i + 1开始
for (int j = i + 1; j < nums.length; j++) {
//双重遍历,如果相加等于target则返回下标
if (nums[i] + nums[j] == target) {
return new int[]{i, j};
}
}
}
throw new IllegalArgumentException("no solution");
}
效果:
两次遍历哈希表
使用哈希表记录值与索引的对应关系,通过target-val1得到val2,通过哈希表找val2的索引
public int[] twoSum2(int[] nums, int target) {
int n = nums.length;
HashMap<Integer, Integer> map = new HashMap<>();
for (int i = 0; i < n; i++) {
map.put(nums[i], i);
}
for (int i = 0; i < n; i++) {
int thatNum = target - nums[i];
Integer index = map.get(thatNum);
if (index != null && !index.equals(i)) {
return new int[]{i, index};
}
}
throw new IllegalArgumentException("no solution");
}
效果:
一次遍历哈希表
在上面一个算法中,我们遍历了两次数组,第一次插入哈希表,第二次找差值,其实可以只遍历一次,找到就返回,没找到再插入哈希表继续找,比如[1,2]这个数组的target是3,找第一个的时候差值是2,去哈希表没找到,就把1放入哈希表,遍历到2的时候差值是1,在哈希表就能找到了
public int[] twoSum3(int[] nums, int target) {
int n = nums.length;
HashMap<Integer, Integer> map = new HashMap<>();
for (int i = 0; i < n; i++) {
int thatNum = target - nums[i];
Integer index = map.get(thatNum);
if (index != null && !index.equals(i)) {
return new int[]{i, index};
}
map.put(nums[i], i);
}
throw new IllegalArgumentException("no solution");
}
效果: